import javax.microedition.lcdui.*;

public class goResult extends Form implements CommandListener, ItemCommandListener {
 private midlet midlet;
 private Display dpy;
 private Displayable prev;

 private Command cmdOK, cmdPress;
 private StringItem item;
 private ImageItem iitem;
 private Image img;
 private goForm res;

 public goResult (midlet midlet, goForm res, String s) {
  super("");
  this.midlet = midlet;
  this.res=res;
  dpy = Display.getDisplay(midlet);
  prev = dpy.getCurrent();
  cmdPress=new Command("", Command.ITEM, 1);

  int k,i=0,p=-1,t,j;
  if (options.mode==0) { //  
   for (i=0; i<24; i++) {
    for (j=0; j<data.points[i]; j++) {
     if ((data.chapterText[i][j]).startsWith (s)==true) {
      appendItem (this,i,j);
      i=24; break;
     }
    }
    res.setTitle (": "+i*4+"%");
   }
  }
  else if (options.mode==1) { //  
   for (i=0; i<8; i++) {
    for (j=0; j<data.signsImages[i]; j++) {
     if (data.signsNames[i][j].substring(1).startsWith(s)==true) {
      appendImageItem (this,i,j);
      i=8; break;
     }
    }
    res.setTitle (": "+i*16+"%");
   }
  }
  if (size()==0) {
   append (new StringItem ("","  "+(options.mode==0 ? " ": " ")+s));
  }
  res.setTitle ("  "+(options.mode==0 ? "": ""));

  cmdOK = new Command ("", Command.BACK, 1);
  addCommand(cmdOK);
  setCommandListener(this);
  setTitle ((options.mode==0 ? " ":" ")+s);
  dpy.setCurrent(this);
 }

 private void appendItem (goResult form, int i, int j) {
  int p = data.chapterText[i][j].indexOf (' ');
  int k = 32+p;
  if (data.chapterText[i][j].length()<k) k=data.chapterText[i][j].length();
  
  item=new StringItem (""+(i+1)+"."+(j+1),data.chapterText[i][j].substring(p,k)+"...");
  item.addCommand (cmdPress);
  item.setDefaultCommand(cmdPress);
  item.setItemCommandListener(this);
  form.append (item);
 }

 private void appendImageItem (goResult form, int i, int j) {
  String st=data.signsNames[i][j].substring(1);
  int p=st.indexOf(' ');
  try {
   img=Image.createImage("/"+st.substring(0,p)+".png");
  }
  catch (java.io.IOException e) {}
  iitem=new ImageItem (st, img, Item.LAYOUT_CENTER, "");
  iitem.addCommand (cmdPress);
  iitem.setDefaultCommand(cmdPress);
  iitem.setItemCommandListener(this);
  form.append (iitem);
 }

 public void commandAction(Command c, Displayable d) {
  if (c==cmdOK) {
   dpy.setCurrent(prev);
  }
 }

 public void commandAction (Command c, Item i) {
  if (c==cmdPress) { 
   if (options.mode==0) {
    String s=i.getLabel();
    int p=s.indexOf('.');
    int chapter= Integer.parseInt(s.substring (0,p));
    int number=Integer.parseInt(s.substring (p+1));
    pointForm point = new pointForm (midlet, chapter, number);
    dpy.setCurrent (point);
   }
   else if (options.mode==1) {
    String s=i.getLabel().substring (0,i.getLabel().indexOf(" "));
    int p=s.indexOf('.');
    int p2=s.lastIndexOf('.');
    int chapter=Integer.parseInt(s.substring(0,p));
    int number, subnumber;
    if (p==p2) {
     number=Integer.parseInt(s.substring(p+1));
     subnumber=0;
    }
    else {
     number=Integer.parseInt(s.substring(p+1,p2));
     subnumber=Integer.parseInt(s.substring(p2+1));
    }
    s=" "+chapter+"."+number;
    if (subnumber!=0) s+=("."+subnumber);
    signForm sign = new signForm (midlet,s,chapter,number,subnumber);
    dpy.setCurrent (sign);
   }
  }
 }

}
